Ext.define('DSS.addon.IlluminantTest', {
    extend : 'DSS.component.Base',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    topPanel:null,
    topLabel:null,
    grafic : null,
    middlePanel : null,
    sliderPanel:null,
    buttonPanel:null,
    btnSend:null,
    btnTest:null,
    iDefaultWidth : 150,
    iDefaultHeight : 293,
    nFieldPercent:null,
    nFieldSlider:null,
    btnMin:null,
    btnMax:null,
    btnInc:null,
    btnDec:null,
    btnMid:null,
    winWait:null,
    fHasActionDone:false,
    fCanActionDone:false,
    setHeight : function(oHeight) {
    	this.bottomPanel.setHeight(oHeight -85);
        this.leftPanel.setHeight(oHeight -90);
        this.rightPanel.setHeight(oHeight -90);
        this.leftButtonPanel.setHeight(oHeight -120);
        this.rightButtonPanel.setHeight(oHeight -120);
        
        this.grafic.setHeight(oHeight -90 -95);
        this.sliderPanel.setHeight(oHeight -140);
        this.nFieldSlider.setHeight(oHeight -180);
        this.iDefaultHeight = oHeight - 62;
        this.callParent(arguments);
    },
    fSetSlider:false,
    setSlider:function(value) {
    	if (this.dssEditor.editControls.dsid.getValue()==null)
    		return;
    	if (this.fSetSlider)
    		return;
    	this.fSetSlider=true;
        if (value>100)
            value=100;
        if (value<0)
            value=0;
        this.nFieldPercent.setValue(value);
        this.nFieldSlider.setValue(value);
        if (this.dssEditor.editControls.dsid.isValid())
        {
            var sSelected=this.dssEditor.editControls.dsid.getValue();
            dss.raiseEvent('led-wizard.demo',{actions:'setValue',dsid:this.dssEditor.editControls.dsid.getValue(),value:Math.floor((value*255)/100)});
        }
        this.fSetSlider=false;
    },
    setTestButton:function () {
        if (fActive) {
        	this.btnTest.setIcon('/framework/images/dss/stop.png');
        	this.btnReset.setDisabled(true);
        	this.btnSend.setDisabled(true);
        } else {
        	this.btnTest.setIcon('/framework/images/dss/start.png');
        	var oDev=this.dssEditor.editControls.dsid.getValue();
        	var oIllu=this.dssEditor.editControls.catalogeID.getValue();
        	   	
        	if (oDev!=null)
        	{
        		this.btnReset.setDisabled(!this.fHasActionDone);
        		this.btnSend.setDisabled(true);	
        		if (oIllu!=null) {
        			var oRecord=Ext.data.StoreManager.lookup('illuminateTypeStore').findRecord('_id',oIllu,0,false,false,true);
        			if (oRecord.get('ability')!=0) {
        				this.btnSend.setDisabled(false);	
        			} 
        		}
        	} else 
        		this.btnReset.setDisabled(true);	        	        	        	
        }
        if (lastValue!=null) {
        	this.fSetSlider=true;
        	this.nFieldSlider.setValue(lastValue);
        	this.nFieldPercent.setValue(lastValue);
        	this.fSetSlider=false;
        }
    },
    constructor : function(config) {
        var me = this;
        
        this.winWait= Ext.create('DSS.component.WaitForServerStepper',{
        	eventNameStart:'led-wizard.prog',
        	eventNameStep:'led-wizard.step',
        	endCallback:function () {me.dssEditor.fireEvent('save', null);}
        });
        this.btnSend=Ext.create('Ext.Button',{
            text:_('Send Dimmcurve'),
            width:200,
            height:30,
            margin: '0 20 0 0',
            //margin: '0 0 5 0',
            handler: function () {                
                if (me.dssEditor.editControls.dsid.isValid())
                    if (me.dssEditor.editControls.catalogeID.isValid())  {
                        if ( dss.staticDataModel.getDevice(me.dssEditor.editControls.dsid.getValue()).outputMode != 22 ) {
                            var messageBox = Ext.create('Ext.window.MessageBox', {
                            });
                                                
                            messageBox.show({
                                 title:_('Hint'),
                                 msg: _('The output mode of the device is currently switched. It will be changed to dimmed.'),
                                 buttons:Ext.MessageBox.OK,                         
                                 icon: Ext.MessageBox.INFO,
                                 fn: function (buttonID) {
                                     me.fHasActionDone=true;
                                     me.winWait.start({actions:'programmCurve',dsid:me.dssEditor.editControls.dsid.getValue(),curve_id:me.dssEditor.editControls.catalogeID.getValue()});
                                     me.updateLabels();                                     
                                 }
                            });
                        } else {
                            me.fHasActionDone=true;
                            me.winWait.start({actions:'programmCurve',dsid:me.dssEditor.editControls.dsid.getValue(),curve_id:me.dssEditor.editControls.catalogeID.getValue()});
                            me.updateLabels();
                        }
                    }
            }
        });
        this.btnReset=Ext.create('Ext.Button',{
            text:_('Reset Dimmcurve'),
            width:200,
            height:30,
            //margin: '5 0 5 0',
            handler: function () {                
                if (me.dssEditor.editControls.dsid.isValid()) {
                	me.fHasActionDone=true;
                	me.winWait.start({actions:'programmCurve',dsid:me.dssEditor.editControls.dsid.getValue(),curve_id:-1});
                }
            }
        });
        this.btnTest=Ext.create('Ext.Button',{
        	width:150,
        	margin: '3 0 20 0',
        	text:_('Test Dimmcurve'),
        	icon:'/framework/images/dss/start.png',
            handler: function () {
                if (me.dssEditor.editControls.dsid.isValid())
                {   
                    var Result = dss.ajaxSyncRequest('/json/device/getConfig', {
                        dsid: me.dssEditor.editControls.dsid.getValue(),
                        'class': 3,
                        index: 0x00           
                    });
                    Result = JSON.parse(Result);
                    if ((Result.result.value ==22) || (Result.result.value ==20)) {
                        dss.raiseEvent('led-wizard.demo',{actions:'toggleDemoModus',dsid:me.dssEditor.editControls.dsid.getValue()});  
                        fActive=!fActive;
                    } else {

                        var messageBox = Ext.create('Ext.window.MessageBox', {
                        });
                                            
                        messageBox.show({
                             title:_('Error'),
                             msg: _('The output mode of the device is currently switched. Please go to the configurator hardware tab to switch back to "dimmed".'),
                             buttons:Ext.MessageBox.OK,                         
                             icon: Ext.Msg.WARNING 
                        });
                    }
                }                
            }
        });
        this.btnMax=Ext.create('Ext.Button',{
            text:_('Max'),
            width:46,
            margin: '0 0 32 0',
            handler: function() {
                me.setSlider(100);
            }
        });
        this.btnInc = Ext.create('Ext.button.Button', {
            iconCls : 'my-icon-up-action',
            iconAlign: "top",
            id:'incButtonWeilsSoSchlechtZuPositionierenIst',
            width:46,
            margin: '0 0 32 0',
            handler: function() {
                me.setSlider(me.nFieldSlider.getValue()+10);
            }
        });
        this.btnMid=Ext.create('Ext.Button',{
            text:_('50%'),
            width:46,
            margin: '0 0 32 0',
            handler: function() {
                me.setSlider(50);
            }
        });
        this.ckbLeistungsZusatz=Ext.create('Ext.form.field.Checkbox', {
            boxLabel : _('Use Leistungszusatz'),
            allowBlank : false,
            hidden:true
        });
        this.btnDec = Ext.create('Ext.button.Button', {
            iconCls : 'my-icon-down-action',
            iconAlign: "top",
            id:'decButtonWeilsSoSchlechtZuPositionierenIst',
            width:46,
            margin: '0 0 32 0',
            handler: function() {
                me.setSlider(me.nFieldSlider.getValue()-10);
            }
        });
        this.btnMin=Ext.create('Ext.Button',{
            text:_('Min'),
            width:46,
            margin: '0 0 0 0',
            handler: function() {
                me.setSlider(0);
            }
        });
        this.btnMinDim=Ext.create('Ext.Button',{
            text:_('-'),
            width:46,
            margin: '0 0 32 0',
            handler: function() {
            	var devID=me.dssEditor.editControls.catalogeID.getValue();
            	if (devID==null)
            		return;
            	var oRecord=Ext.data.StoreManager.lookup('illuminateTypeStore').findRecord('_id',devID,0,false,false,true);
        		if (oRecord!=null) {
        			me.setSlider(oRecord.get('dimmMinimum'));
        		} 		        			                
            }
        });
       
        this.topLabelLM=Ext.create('Ext.form.field.Display',{
            fieldLabel:_('illuminant'),
            width:700,
            height:40,
            value:'-'
        });
        this.topLabelDevice=Ext.create('Ext.form.field.Display',{
            fieldLabel:_('selected Device'),
            width:700,
            value:'-'
        });
        this.nFieldPercent=Ext.create('Ext.form.field.Number',{
            minValue:0,
            maxValue:100,
            step:1,
            margin: '0 0 32 0',
            decimalPrecision:0,
            width:50,
            listeners: {
                change: function(field,value) {
                    me.setSlider(value);
                }
            }
        });
        this.nFieldSlider=Ext.create('Ext.slider.Single', {
            width: 40,
            value: 50,
            increment: 1,
            minValue: 0,
            maxValue: 100,
            vertical:true,
            padding : "0 0 0 12",
            listeners: {
                changecomplete: function(field,value) {
                    me.setSlider(value);
                }
            }
        });
        var chartStore = Ext.data.StoreManager.lookup('illuminateChartValues');
        var tempChartStore = Ext.create('Ext.data.Store', {
            fields : [ '_id','value','window'],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });   
        chartStore.each(function(record) {
            var oNewRecord = record.copy();
            tempChartStore.add(oNewRecord);
        });

        this.grafic = Ext.create('Ext.chart.Chart', {
            store : tempChartStore,
            height : 180,
            width: 450,
            animate: true,
            series: [ {
                         type: 'line',
                         xField: '_id',
                         yField: 'value',
                         fill: true,
                         markerConfig: {
                             type: 'circle',
                             radius: 4,
                             'fill': '#ffff00'
                         },
                         style: {
                        	 fill:'#dff6e8',
                        	 stroke:'#99E8BC',
                        	 opacity: 1
                         }
                     },
                     {
                         type: 'line',
                         xField: '_id',
                         yField: 'window',
                         fill: true,
                         markerConfig: {
                             type: 'circle',
                             radius: 4,
                             'fill': '#ffff00'
                         },
                         style: {
                        	 fill:'#ffff00',
                        	 stroke:'ffff00',
                        	 opacity: 0.2
                         },
                         showMarkers:false
                     }]
        });
        this.verticalLabel=Ext.create('Ext.draw.Component', {
            viewBox: false,
            autoSize: true,
            height: 180,
            width:20,
            padding:"50 0 0 0",
            items: [{
                type: 'text',
                text: "   " + _('brightness'),
                fill: '#005138',
                font: '12px tahoma,arial,verdana,sans-serif',
                rotate: {
                    degrees: 270
                }
            }]
        });
        
        this.graficSubContainer=Ext.create('Ext.panel.Panel', {
            border : 0,
            height : 180,
            width : 470,
            layout : {
                type : 'hbox',
                flex:0
            },
            items : [this.verticalLabel,this.grafic],
            scroll : 'horizontal'
        });
        
        
        this.leftButtonPanel=Ext.create('Ext.panel.Panel',{
            layout : {
                type : 'vbox',
                align:'center'
            },
            border:0,
            width:50,
            enabled:false,
            items:[this.nFieldPercent,this.btnInc,this.btnDec]
        }); 

        this.rightButtonPanel=Ext.create('Ext.panel.Panel',{
            layout : {
                type : 'vbox',
                align:'center'
            },
            border:0,
            width:50,
            enabled:false,
            items:[this.btnMax,this.btnMid,this.btnMinDim,this.btnMin]
        });
       
        this.sliderPanel=Ext.create('Ext.panel.Panel',{
            layout:{type:'hbox'}, 
            width:150,
            border:0,
            items:[this.leftButtonPanel,this.nFieldSlider,this.rightButtonPanel]
        });
        
        
        this.bigButtonPanel=Ext.create('Ext.panel.Panel',{
            layout : {
                type : 'hbox',
                align:'center',
                pack:'center'
            },
            align:'middle',
            width:530,
            height:45,
            border:0,
            items:[this.btnSend,this.btnReset]
        });
        
        this.bottonLabel=Ext.create('Ext.form.field.Display', {
            border : 0,
            height:10,
            value:_('phase angle'),
             style: {
                fontSize: '11px'
            }
        });
        
        this.leftPanel=Ext.create('Ext.form.FieldSet',{
            layout : {
                type : 'vbox',
                align:'center',
                pack:'center'
            },
            padding: '5 20 0 20',
            width:550,
            height:30,
            align:'middle',

            border:1,
            items:[this.bigButtonPanel,this.graficSubContainer,this.bottonLabel]
        });
        
        this.rightPanel=Ext.create('Ext.form.FieldSet',{
            layout : {
                type : 'vbox'
            },
            width:194,
            height:30,
            align:'middle',
            padding:"20 0 0 20",
            border:1,
            items:[this.btnTest,this.sliderPanel]
        });
        
         this.bottomPanel=Ext.create('Ext.panel.Panel',{
            layout : {
                type : 'hbox'
            },
            width:754,
            height:200,
            border:0,
            items:[this.leftPanel,this.rightPanel]
        });
        Ext.apply(this, {
            layout : {
                type : 'vbox'
            },
            padding: '0 0 0 10',
            width:754,
            items : [this.topLabelDevice,this.topLabelLM,this.bottomPanel, this.ckbLeistungsZusatz ]
        });
        this.callParent(arguments);	
        fChangedCallback.push(function () {me.setTestButton();});
    },
    updateChartStore : function() {
        var me = this;
        var chartStore = Ext.data.StoreManager.lookup('illuminateChartValues');
        if (this.grafic !== null) {
            this.grafic.getStore().removeAll();
            chartStore.each(function(record) {
                var oNewRecord = record.copy();
                me.grafic.getStore().add(oNewRecord);
            });          
        }
    },
    updateLabels : function () {
        var sString ="";
    	var oDev=this.dssEditor.editControls.dsid.getValue();
    	var oIllu=this.dssEditor.editControls.catalogeID.getValue();
    	var fDisabled=false;
    	if (oIllu!=null) {
    		var oRecord=Ext.data.StoreManager.lookup('illuminateTypeStore').findRecord('_id',oIllu,0,false,false,true);
    		if (oRecord!=null) {
    			var manuID=oRecord.get('manufactureID');
    			var oVendorRecord=Ext.data.StoreManager.lookup('illuminateVendorStore').findRecord('_id',manuID,0,false,false,true);
    			sString='<table><tr><td style="padding-right:5px;height:16px;">';
    			if (oRecord.get('ability')==0) {
    				sString+='<img src="images/status_error.png"/>';
    			} else if (oRecord.get('ability')==1) {
    				sString+='<img src="images/status_critical.png"/>';
    			} else {
    				sString +='<img src="images/status_ok.png"/>';
    			}
    			sString+='</td><td>'+oVendorRecord.get('vendor').substr(1) + ' ' + oRecord.get('socket') + ' ' + oRecord.get('name') + ' ' + oRecord.get('watt') + 'W ' + oRecord.get('colortemp')+"K</td></tr></table>";
    			this.topLabelLM.setValue(sString);
    			if (oRecord.get('ability')==0) {
    				fDisabled=true;
    			} else {    			
    				this.btnMinDim.setText(oRecord.get('dimmMinimum')+"%");
    			}
    		} else    		
    			this.topLabelLM.setValue('-');
    	} else {
    		this.topLabelLM.setValue('-');
    	}
    	    	
    	
    	if (oDev!=null) {
	    	var oDevice = dss.staticDataModel.getDevice(oDev);	
	    	
	        sString = '<table><tr><td style="padding-right:5px;height:16px;"><img src="'+dss.staticDataModel.getImageForDevice(oDevice)+'"></td><td>'  + oDevice.name + _(" in ") + dss.staticDataModel.getNameForZone(oDevice.ZoneID) + '</td></tr></table>';
	        
	        this.topLabelDevice.setValue(sString);
	        this.btnReset.setDisabled(!this.fHasActionDone);
	        this.btnDec.setDisabled(!this.fHasActionDone);
	        this.btnInc.setDisabled(!this.fHasActionDone);
	        this.btnMax.setDisabled(!this.fHasActionDone);
	        this.btnMid.setDisabled(!this.fHasActionDone);
	        this.btnMin.setDisabled(!this.fHasActionDone);
	        this.btnMinDim.setDisabled(!this.fHasActionDone);
	        this.btnTest.setDisabled(!this.fHasActionDone);
	        this.nFieldSlider.setDisabled(!this.fHasActionDone);
	        this.nFieldPercent.setDisabled(!this.fHasActionDone);
	       
    	} else {
    		this.topLabelDevice.setValue('-');
	        this.btnReset.setDisabled(true);
	        this.btnDec.setDisabled(true);
	        this.btnInc.setDisabled(true);
	        this.btnMax.setDisabled(true);
	        this.btnMid.setDisabled(true);
	        this.btnMin.setDisabled(true);
	        this.btnMinDim.setDisabled(true);
	        this.btnTest.setDisabled(true);
	        this.nFieldSlider.setDisabled(true);
	        this.nFieldPercent.setDisabled(true);
	        
    	}
    	
        
    	if ((oDev!=null)&&(oIllu!=null)) {
    		this.btnSend.setDisabled(false);
    		this.ckbLeistungsZusatz.setDisabled(false);
    		this.fCanActionDone=true;
    	} else {
    		this.btnSend.setDisabled(true);
    		this.ckbLeistungsZusatz.setDisabled(true);
    	}
    	   	
    	if (fDisabled) {
    		this.btnSend.setDisabled(true);
    		this.ckbLeistungsZusatz.setDisabled(true);
	        this.btnReset.setDisabled(true);
	        this.btnDec.setDisabled(true);
	        this.btnInc.setDisabled(true);
	        this.btnMax.setDisabled(true);
	        this.btnMid.setDisabled(true);
	        this.btnMin.setDisabled(true);
	        this.btnMinDim.setDisabled(true);
	        this.btnTest.setDisabled(true);
	        this.nFieldSlider.setDisabled(true);
	        this.nFieldPercent.setDisabled(true);
    	}    	
    },
    reset : function() {
    	var me=this;
    	this.fCanActionDone=false;
    	this.fHasActionDone=false;
    	 this.dssEditor.oTabPanelParent.on('tabchange', function ( tabPanel, newCard, oldCard, eOpts) {
         	me.updateLabels();
         });
    },
    setValue : function(value) {
       	this.fHasActionDone=true;
       	var me=this;
   	 this.dssEditor.oTabPanelParent.on('tabchange', function ( tabPanel, newCard, oldCard, eOpts) {
      	me.updateLabels();
      });
    },
    isValid : function() {
        return true;
    },
    getValue : function() {
    }
});
